Index: boot/arch/arm32/loader/asm.h
===================================================================
--- boot/arch/arm32/loader/asm.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/arm32/loader/asm.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -40,13 +40,4 @@
 
 
-/** Copies cnt bytes from dst to src.
- *
- * @param dst Destination address.
- * @param src Source address.
- * @param cnt Count of bytes to be copied.
- */
-#define memcpy(dst, src, cnt) __builtin_memcpy((dst), (src), (cnt))
-
-
 /** Called when the CPU is switched on.
  *
Index: boot/arch/arm32/loader/main.c
===================================================================
--- boot/arch/arm32/loader/main.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/arm32/loader/main.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -43,4 +43,5 @@
 #include <macros.h>
 #include <string.h>
+#include <memstr.h>
 
 #include "mm.h"
Index: boot/arch/ia64/loader/asm.h
===================================================================
--- boot/arch/ia64/loader/asm.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ia64/loader/asm.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -34,13 +34,10 @@
 #include "main.h"
 
-#define PAGE_WIDTH	14
-#define PAGE_SIZE	(1 << PAGE_WIDTH)
+#define PAGE_WIDTH  14
+#define PAGE_SIZE   (1 << PAGE_WIDTH)
 
-#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+#define BALLOC_MAX_SIZE  (128 * 1024)
 
 extern void halt(void);
-/*extern void jump_to_kernel(void *entry, uint64_t cfg, bootinfo_t *bootinfo,
-	unsigned int bootinfo_size) __attribute__((noreturn));*/
-
 extern void jump_to_kernel(void *) __attribute__((noreturn));
 
Index: boot/arch/mips32/loader/asm.h
===================================================================
--- boot/arch/mips32/loader/asm.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/mips32/loader/asm.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -33,6 +33,4 @@
 #define PAGE_WIDTH  14
 
-#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
-
 void jump_to_kernel(void *entry, void *bootinfo) __attribute__((noreturn));
 
Index: boot/arch/mips32/loader/main.c
===================================================================
--- boot/arch/mips32/loader/main.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/mips32/loader/main.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -27,9 +27,10 @@
  */
 
-#include "main.h" 
+#include "main.h"
 #include <printf.h>
 #include <align.h>
 #include <macros.h>
 #include <string.h>
+#include <memstr.h>
 #include "msim.h"
 #include "asm.h"
Index: boot/arch/ppc32/loader/Makefile
===================================================================
--- boot/arch/ppc32/loader/Makefile	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/Makefile	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -62,9 +62,11 @@
 SOURCES = \
 	main.c \
-	ofwarch.c \
 	_components.c \
-	../../../genarch/ofw.c \
 	../../../generic/printf.c \
 	../../../generic/string.c \
+	../../../genarch/balloc.c \
+	../../../genarch/ofw.c \
+	../../../genarch/ofw_tree.c \
+	ofwarch.c \
 	asm.S \
 	boot.S
@@ -73,6 +75,6 @@
 	$(KERNELDIR)/kernel.bin \
 	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/app/init/init \
 	$(USPACEDIR)/srv/loader/loader \
-	$(USPACEDIR)/app/init/init \
 	$(USPACEDIR)/srv/devmap/devmap \
 	$(USPACEDIR)/srv/bd/rd/rd \
@@ -99,6 +101,6 @@
 	$(USPACEDIR)/app/tester/tester \
 	$(USPACEDIR)/app/trace/trace \
-	$(USPACEDIR)/app/klog/klog \
-	$(USPACEDIR)/app/bdsh/bdsh
+	$(USPACEDIR)/app/bdsh/bdsh \
+	$(USPACEDIR)/app/klog/klog
 
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
Index: boot/arch/ppc32/loader/_link.ld.in
===================================================================
--- boot/arch/ppc32/loader/_link.ld.in	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/_link.ld.in	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -19,3 +19,8 @@
 [[COMPONENTS]]
 	}
+	
+	/DISCARD/ : {
+		*(.comment);
+		*(.note*);
+	}
 }
Index: boot/arch/ppc32/loader/asm.S
===================================================================
--- boot/arch/ppc32/loader/asm.S	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/asm.S	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -29,4 +29,5 @@
 #include "asm.h"
 #include "regname.h"
+#include "ofwarch.h"
 
 .macro SMC_COHERENCY addr
@@ -45,6 +46,15 @@
 
 .macro TLB_FLUSH reg
-	tlbie \reg
-	addi \reg, \reg, 0x1000
+	li \reg, 0
+	sync
+	
+	.rept 64
+		tlbie \reg
+		addi \reg, \reg, 0x1000
+	.endr
+	
+	eieio
+	tlbsync
+	sync
 .endm
 
@@ -54,4 +64,5 @@
 .global memcpy
 .global jump_to_kernel
+.global balloc_base
 
 halt:
@@ -62,5 +73,5 @@
 	addi r6, r3, -4
 	addi r4, r4, -4
-	beq	2f
+	beq 2f
 	
 	andi. r0, r6, 3
@@ -69,55 +80,48 @@
 	
 	1:
-	
-	lwz r7, 4(r4)
-	lwzu r8, 8(r4)
-	stw r7, 4(r6)
-	stwu r8, 8(r6)
-	bdnz 1b
-	
-	andi. r5, r5, 7
+		lwz r7, 4(r4)
+		lwzu r8, 8(r4)
+		stw r7, 4(r6)
+		stwu r8, 8(r6)
+		bdnz 1b
+		
+		andi. r5, r5, 7
 	
 	2:
-	
-	cmplwi 0, r5, 4
-	blt 3f
-	
-	lwzu r0, 4(r4)
-	addi r5, r5, -4
-	stwu r0, 4(r6)
+		cmplwi 0, r5, 4
+		blt 3f
+		
+		lwzu r0, 4(r4)
+		addi r5, r5, -4
+		stwu r0, 4(r6)
 	
 	3:
-	
-	cmpwi 0, r5, 0
-	beqlr
-	mtctr r5
-	addi r4, r4, 3
-	addi r6, r6, 3
+		cmpwi 0, r5, 0
+		beqlr
+		mtctr r5
+		addi r4, r4, 3
+		addi r6, r6, 3
 	
 	4:
-	
-	lbzu r0, 1(r4)
-	stbu r0, 1(r6)
-	bdnz 4b
-	blr
+		lbzu r0, 1(r4)
+		stbu r0, 1(r6)
+		bdnz 4b
+		blr
 	
 	5:
-	
-	subfic r0, r0, 4
-	mtctr r0
+		subfic r0, r0, 4
+		mtctr r0
 	
 	6:
-	
-	lbz r7, 4(r4)
-	addi r4, r4, 1
-	stb r7, 4(r6)
-	addi r6, r6, 1
-	bdnz 6b
-	subf r5, r0, r5
-	rlwinm. r7, r5, 32-3, 3, 31
-	beq 2b
-	mtctr r7
-	b 1b
-
+		lbz r7, 4(r4)
+		addi r4, r4, 1
+		stb r7, 4(r6)
+		addi r6, r6, 1
+		bdnz 6b
+		subf r5, r0, r5
+		rlwinm. r7, r5, 32-3, 3, 31
+		beq 2b
+		mtctr r7
+		b 1b
 
 jump_to_kernel:
@@ -128,6 +132,4 @@
 	# r6 = bytes to copy
 	# r7 = real_mode (pa)
-	# r8 = framebuffer (pa)
-	# r9 = scanline
 	
 	# disable interrupts
@@ -153,16 +155,20 @@
 	rfi
 
+.align PAGE_WIDTH
+balloc_base:
+	.fill BALLOC_MAX_SIZE
+
 .section REALMODE, "ax"
+
 .align PAGE_WIDTH
 .global real_mode
-
 real_mode:
 	
 	# copy kernel to proper location
 	#
+	# r3 = bootinfo (pa)
+	# r4 = bootinfo_size
 	# r5 = trans (pa)
 	# r6 = bytes to copy
-	# r8 = framebuffer (pa)
-	# r9 = scanline
 	
 	li r31, PAGE_SIZE >> 2
@@ -343,97 +349,20 @@
 	# flush TLB
 	
-	li r31, 0
-	sync
-	
 	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	TLB_FLUSH r31
-	
-	eieio
-	tlbsync
-	sync
 	
 	# start the kernel
 	#
-	# pc = KERNEL_START_ADDR
+	# pc = PA2KA(BOOT_OFFSET)
 	# r3 = bootinfo (pa)
-	# sprg0 = KA2PA(KERNEL_START_ADDR)
+	# sprg0 = BOOT_OFFSET
 	# sprg3 = physical memory size
 	# sp = 0 (pa)
 	
-	lis r31, KERNEL_START_ADDR@ha
-	addi r31, r31, KERNEL_START_ADDR@l
-	
+	lis r31, PA2KA(BOOT_OFFSET)@ha
+	addi r31, r31, PA2KA(BOOT_OFFSET)@l
 	mtspr srr0, r31
 	
-	subis r31, r31, 0x8000
+	lis r31, BOOT_OFFSET@ha
+	addi r31, r31, BOOT_OFFSET@l
 	mtsprg0 r31
 	
@@ -454,3 +383,5 @@
 .global trans
 trans:
-	.space (TRANS_SIZE * TRANS_ITEM_SIZE)
+	.rept TRANS_SIZE
+	.int 0
+	.endr
Index: boot/arch/ppc32/loader/asm.h
===================================================================
--- boot/arch/ppc32/loader/asm.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/asm.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -30,21 +30,31 @@
 #define BOOT_ppc32_ASM_H_
 
-#define PAGE_SIZE 4096
-#define PAGE_WIDTH 12
+#define PAGE_WIDTH  12
+#define PAGE_SIZE   (1 << PAGE_WIDTH)
 
-#define TRANS_SIZE 1024
-#define TRANS_ITEM_SIZE 4
+#define TRANS_SIZE   1024
+#define BOOT_OFFSET  0x8000
 
-#define KERNEL_START_ADDR 0x80008000
+#define BALLOC_MAX_SIZE  (128 * 1024)
 
 #ifndef __ASM__
 
-#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+#include "types.h"
+#include "main.h"
+#include "ofwarch.h"
 
-extern void *trans[TRANS_SIZE];
+#define PA2KA(x)  (((uintptr_t) (x)) + 0x80000000)
+
+extern uint8_t balloc_base[BALLOC_MAX_SIZE];
+extern uintptr_t trans[TRANS_SIZE];
 
 extern void halt();
-extern void jump_to_kernel(void *bootinfo, unsigned int bootinfo_size, void *trans, unsigned int kernel_size, void *real_mode, void *fb, unsigned int scanline) __attribute__((noreturn));
+extern void jump_to_kernel(void *bootinfo, unsigned int bootinfo_size,
+    uintptr_t trans[], unsigned int kernel_size, void *real_mode) __attribute__((noreturn));
 extern void real_mode();
+
+#else
+
+#define PA2KA(x)  ((x) + 0x80000000)
 
 #endif
Index: boot/arch/ppc32/loader/main.c
===================================================================
--- boot/arch/ppc32/loader/main.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/main.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -27,21 +27,40 @@
  */
 
-#include "main.h" 
 #include <printf.h>
-#include "asm.h"
-#include "_components.h"
 #include <ofw.h>
 #include <align.h>
 #include <macros.h>
 #include <string.h>
+#include "main.h"
+#include "asm.h"
+#include "_components.h"
 
-#define HEAP_GAP 1024000
+static bootinfo_t bootinfo;
+static component_t components[COMPONENTS];
+static char *release = STRING(RELEASE);
 
-bootinfo_t bootinfo;
+#ifdef REVISION
+	static char *revision = ", revision " STRING(REVISION);
+#else
+	static char *revision = "";
+#endif
 
+#ifdef TIMESTAMP
+	static char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
+#else
+	static char *timestamp = "";
+#endif
+
+/** Print version information. */
+static void version_print(void)
+{
+	printf("HelenOS PPC32 Bootloader\nRelease %s%s%s\n"
+	    "Copyright (c) 2006 HelenOS project\n\n",
+	    release, revision, timestamp);
+}
 
 static void check_align(const void *addr, const char *desc)
 {
-	if ((unsigned int) addr % PAGE_SIZE != 0) {
+	if ((uintptr_t) addr % PAGE_SIZE != 0) {
 		printf("Error: %s not on page boundary, halting.\n", desc);
 		halt();
@@ -49,48 +68,10 @@
 }
 
-
-static void fix_overlap(void *va, void **pa, const char *desc, unsigned int *top)
+static void check_overlap(const void *pa, const char *desc, const uintptr_t top)
 {
-	if ((unsigned int) *pa + PAGE_SIZE < *top) {
-		printf("Warning: %s overlaps kernel physical area\n", desc);
-		
-		void *new_va = (void *) (ALIGN_UP((unsigned int) KERNEL_END + HEAP_GAP, PAGE_SIZE) + *top);
-		void *new_pa = (void *) (HEAP_GAP + *top);
-		*top += PAGE_SIZE;
-		
-		if (ofw_map(new_pa, new_va, PAGE_SIZE, 0) != 0) {
-			printf("Error: Unable to map page aligned memory at %L (physical %L), halting.\n", new_va, new_pa);
-			halt();
-		}
-		
-		if ((unsigned int) new_pa + PAGE_SIZE < KERNEL_SIZE) {
-			printf("Error: %s cannot be relocated, halting.\n", desc);
-			halt();	
-		}
-		
-		printf("Relocating %L -> %L (physical %L -> %L)\n", va, new_va, *pa, new_pa);
-		*pa = new_pa;
-		memcpy(new_va, va, PAGE_SIZE);
+	if ((uintptr_t) pa + PAGE_SIZE < top) {
+		printf("Error: %s overlaps destination physical area\n", desc);
+		halt();
 	}
-}
-
-char *release = STRING(RELEASE);
-
-#ifdef REVISION
-	char *revision = ", revision " STRING(REVISION);
-#else
-	char *revision = "";
-#endif
-
-#ifdef TIMESTAMP
-	char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
-#else
-	char *timestamp = "";
-#endif
-
-/** Print version information. */
-static void version_print(void)
-{
-	printf("HelenOS PPC32 Bootloader\nRelease %s%s%s\nCopyright (c) 2006 HelenOS project\n\n", release, revision, timestamp);
 }
 
@@ -98,14 +79,5 @@
 {
 	version_print();
-	
-	component_t components[COMPONENTS];
 	init_components(components);
-		
-	unsigned int i;
-	for (i = 0; i < COMPONENTS; i++)
-		check_align(components[i].start, components[i].name);
-	
-	check_align(&real_mode, "bootstrap trampoline");
-	check_align(&trans, "translation table");
 	
 	if (!ofw_memmap(&bootinfo.memmap)) {
@@ -119,32 +91,38 @@
 	}
 	
-	if (!ofw_screen(&bootinfo.screen))
-		printf("Warning: Unable to get screen properties.\n");
+	check_align(&real_mode, "bootstrap trampoline");
+	check_align(trans, "translation table");
+	check_align(balloc_base, "boot allocations");
 	
-	if (!ofw_macio(&bootinfo.macio))
-		printf("Warning: Unable to get macio properties.\n");
+	unsigned int i;
+	for (i = 0; i < COMPONENTS; i++)
+		check_align(components[i].start, components[i].name);
 	
-	printf("Device statistics\n");
+	void *bootinfo_pa = ofw_translate(&bootinfo);
+	void *real_mode_pa = ofw_translate(&real_mode);
+	void *trans_pa = ofw_translate(trans);
+	void *balloc_base_pa = ofw_translate(balloc_base);
 	
-	if (bootinfo.screen.addr)
-		printf(" screen at %L, resolution %dx%d, %d bpp (scanline %d bytes)\n", bootinfo.screen.addr, bootinfo.screen.width, bootinfo.screen.height, bootinfo.screen.bpp, bootinfo.screen.scanline);
-	
-	if (bootinfo.macio.addr)
-		printf(" macio at %L (size %d bytes)\n", bootinfo.macio.addr, bootinfo.macio.size);
-	
-	void *real_mode_pa = ofw_translate(&real_mode);
-	void *trans_pa = ofw_translate(&trans);
-	void *bootinfo_pa = ofw_translate(&bootinfo);
-	
-	printf("\nMemory statistics (total %d MB)\n", bootinfo.memmap.total >> 20);
+	printf("Memory statistics (total %d MB)\n", bootinfo.memmap.total >> 20);
 	printf(" %L: boot info structure (physical %L)\n", &bootinfo, bootinfo_pa);
 	printf(" %L: bootstrap trampoline (physical %L)\n", &real_mode, real_mode_pa);
-	printf(" %L: translation table (physical %L)\n", &trans, trans_pa);
+	printf(" %L: translation table (physical %L)\n", trans, trans_pa);
+	printf(" %L: boot allocations (physical %L)\n", balloc_base, balloc_base_pa);
 	for (i = 0; i < COMPONENTS; i++)
 		printf(" %L: %s image (size %d bytes)\n", components[i].start, components[i].name, components[i].size);
 	
-	unsigned int top = 0;
+	uintptr_t top = 0;
 	for (i = 0; i < COMPONENTS; i++)
 		top += ALIGN_UP(components[i].size, PAGE_SIZE);
+	top += ALIGN_UP(BALLOC_MAX_SIZE, PAGE_SIZE);
+	
+	if (top >= TRANS_SIZE * PAGE_SIZE) {
+		printf("Error: boot image is too large\n");
+		halt();
+	}
+	
+	check_overlap(bootinfo_pa, "boot info", top);
+	check_overlap(real_mode_pa, "bootstrap trampoline", top);
+	check_overlap(trans_pa, "translation table", top);
 	
 	unsigned int pages = ALIGN_UP(KERNEL_SIZE, PAGE_SIZE) >> PAGE_WIDTH;
@@ -152,10 +130,15 @@
 	for (i = 0; i < pages; i++) {
 		void *pa = ofw_translate(KERNEL_START + (i << PAGE_WIDTH));
-		fix_overlap(KERNEL_START + (i << PAGE_WIDTH), &pa, "kernel", &top);
-		trans[i] = pa;
+		check_overlap(pa, "kernel", top);
+		trans[i] = (uintptr_t) pa;
 	}
 	
 	bootinfo.taskmap.count = 0;
 	for (i = 1; i < COMPONENTS; i++) {
+		if (bootinfo.taskmap.count == TASKMAP_MAX_RECORDS) {
+			printf("\nSkipping superfluous components.\n");
+			break;
+		}
+		
 		unsigned int component_pages = ALIGN_UP(components[i].size, PAGE_SIZE) >> PAGE_WIDTH;
 		unsigned int j;
@@ -163,12 +146,13 @@
 		for (j = 0; j < component_pages; j++) {
 			void *pa = ofw_translate(components[i].start + (j << PAGE_WIDTH));
-			fix_overlap(components[i].start + (j << PAGE_WIDTH), &pa, components[i].name, &top);
-			trans[pages + j] = pa;
+			check_overlap(pa, components[i].name, top);
+			trans[pages + j] = (uintptr_t) pa;
 			if (j == 0) {
-				bootinfo.taskmap.tasks[bootinfo.taskmap.count].addr = (void *) (pages << PAGE_WIDTH);
+				
+				bootinfo.taskmap.tasks[bootinfo.taskmap.count].addr = (void *) PA2KA(pages << PAGE_WIDTH);
 				bootinfo.taskmap.tasks[bootinfo.taskmap.count].size = components[i].size;
 				strncpy(bootinfo.taskmap.tasks[bootinfo.taskmap.count].name,
 				    components[i].name, BOOTINFO_TASK_NAME_BUFLEN);
-
+				
 				bootinfo.taskmap.count++;
 			}
@@ -178,11 +162,22 @@
 	}
 	
-	fix_overlap(&real_mode, &real_mode_pa, "bootstrap trampoline", &top);
-	fix_overlap(&trans, &trans_pa, "translation table", &top);
-	fix_overlap(&bootinfo, &bootinfo_pa, "boot info", &top);
+	uintptr_t balloc_kernel_base = PA2KA(pages << PAGE_WIDTH);
+	unsigned int balloc_pages = ALIGN_UP(BALLOC_MAX_SIZE, PAGE_SIZE) >> PAGE_WIDTH;
+	for (i = 0; i < balloc_pages; i++) {
+		void *pa = ofw_translate(balloc_base + (i << PAGE_WIDTH));
+		check_overlap(pa, "boot allocations", top);
+		trans[pages + i] = (uintptr_t) pa;
+	}
+	
+	pages += balloc_pages;
+	
+	balloc_init(&bootinfo.ballocs, (uintptr_t) balloc_base, balloc_kernel_base);
+	printf("\nCanonizing OpenFirmware device tree...");
+	bootinfo.ofw_root = ofw_tree_build();
+	printf("done.\n");
 	
 	ofw_setup_palette();
 	
 	printf("\nBooting the kernel...\n");
-	jump_to_kernel(bootinfo_pa, sizeof(bootinfo), trans_pa, pages << PAGE_WIDTH, real_mode_pa, (void *) bootinfo.screen.addr, bootinfo.screen.scanline);
+	jump_to_kernel(bootinfo_pa, sizeof(bootinfo), trans_pa, pages << PAGE_WIDTH, real_mode_pa);
 }
Index: boot/arch/ppc32/loader/main.h
===================================================================
--- boot/arch/ppc32/loader/main.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/main.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -30,23 +30,22 @@
 #define BOOT_ppc32_MAIN_H_
 
-#include "ofw.h"
+#include <ofw.h>
+#include <ofw_tree.h>
+#include <balloc.h>
+#include <types.h>
 
-#define TASKMAP_MAX_RECORDS 32
+#define TASKMAP_MAX_RECORDS  32
 
 /** Size of buffer for storing task name in task_t. */
-#define BOOTINFO_TASK_NAME_BUFLEN 32
+#define BOOTINFO_TASK_NAME_BUFLEN  32
 
-/** Struct holding information about single loaded task. */
 typedef struct {
-	/** Address where the task was placed. */
 	void *addr;
-	/** Size of the task's binary. */
-	unsigned int size;
-	/** Task name. */
+	uint32_t size;
 	char name[BOOTINFO_TASK_NAME_BUFLEN];
 } task_t;
 
 typedef struct {
-	unsigned int count;
+	uint32_t count;
 	task_t tasks[TASKMAP_MAX_RECORDS];
 } taskmap_t;
@@ -55,6 +54,6 @@
 	memmap_t memmap;
 	taskmap_t taskmap;
-	screen_t screen;
-	macio_t macio;
+	ballocs_t ballocs;
+	ofw_tree_node_t *ofw_root;
 } bootinfo_t;
 
@@ -62,5 +61,3 @@
 extern void bootstrap(void);
 
-extern memmap_t memmap;
-
 #endif
Index: boot/arch/ppc32/loader/ofwarch.c
===================================================================
--- boot/arch/ppc32/loader/ofwarch.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/ofwarch.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -31,5 +31,5 @@
 #include <printf.h>
 
-typedef int (* ofw_entry_t)(ofw_args_t *args);
+typedef int (*ofw_entry_t)(ofw_args_t *args);
 
 int ofw(ofw_args_t *args)
@@ -49,28 +49,7 @@
 }
 
-int ofw_macio(macio_t *macio)
-{
-	char device_name[BUF_SIZE];
-	
-	if ((ofw_get_property(ofw_aliases, "macio", device_name, sizeof(device_name)) <= 0)
-	    && (ofw_get_property(ofw_aliases, "mac-io", device_name, sizeof(device_name)) <= 0))
-		return false;
-	
-	phandle device = ofw_find_device(device_name);
-	if (device == -1)
-		return false;
-	
-	pci_reg_t pci_reg;
-	if (ofw_get_property(device, "assigned-addresses", &pci_reg, sizeof(pci_reg)) <= 0)
-		return false;
-	
-	macio->addr = (void *) pci_reg.addr.addr_lo;
-	macio->size = pci_reg.size_lo;
-
-	return true;
-}
-
 int ofw_translate_failed(ofw_arg_t flag)
 {
+	/* PearPC returns buggy flag */
 	return 0;
 }
Index: boot/arch/ppc32/loader/regname.h
===================================================================
--- boot/arch/ppc32/loader/regname.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/ppc32/loader/regname.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -31,193 +31,196 @@
 
 /* Condition Register Bit Fields */
-#define	cr0	0
-#define	cr1	1
-#define	cr2	2
-#define	cr3	3
-#define	cr4	4
-#define	cr5	5
-#define	cr6	6
-#define	cr7	7
+#define cr0  0
+#define cr1  1
+#define cr2  2
+#define cr3  3
+#define cr4  4
+#define cr5  5
+#define cr6  6
+#define cr7  7
 
 /* General Purpose Registers (GPRs) */
-#define	r0	0
-#define	r1	1
-#define	r2	2
-#define	r3	3
-#define	r4	4
-#define	r5	5
-#define	r6	6
-#define	r7	7
-#define	r8	8
-#define	r9	9
-#define	r10	10
-#define	r11	11
-#define	r12	12
-#define	r13	13
-#define	r14	14
-#define	r15	15
-#define	r16	16
-#define	r17	17
-#define	r18	18
-#define	r19	19
-#define	r20	20
-#define	r21	21
-#define	r22	22
-#define	r23	23
-#define	r24	24
-#define	r25	25
-#define	r26	26
-#define	r27	27
-#define	r28	28
-#define	r29	29
-#define	r30	30
-#define	r31	31
+#define r0   0
+#define r1   1
+#define r2   2
+#define r3   3
+#define r4   4
+#define r5   5
+#define r6   6
+#define r7   7
+#define r8   8
+#define r9   9
+#define r10  10
+#define r11  11
+#define r12  12
+#define r13  13
+#define r14  14
+#define r15  15
+#define r16  16
+#define r17  17
+#define r18  18
+#define r19  19
+#define r20  20
+#define r21  21
+#define r22  22
+#define r23  23
+#define r24  24
+#define r25  25
+#define r26  26
+#define r27  27
+#define r28  28
+#define r29  29
+#define r30  30
+#define r31  31
 
 /* GPR Aliases */
-#define	sp	1
+#define sp  1
 
 /* Floating Point Registers (FPRs) */
-#define	fr0		0
-#define	fr1		1
-#define	fr2		2
-#define	fr3		3
-#define	fr4		4
-#define	fr5		5
-#define	fr6		6
-#define	fr7		7
-#define	fr8		8
-#define	fr9		9
-#define	fr10	10
-#define	fr11	11
-#define	fr12	12
-#define	fr13	13
-#define	fr14	14
-#define	fr15	15
-#define	fr16	16
-#define	fr17	17
-#define	fr18	18
-#define	fr19	19
-#define	fr20	20
-#define	fr21	21
-#define	fr22	22
-#define	fr23	23
-#define	fr24	24
-#define	fr25	25
-#define	fr26	26
-#define	fr27	27
-#define	fr28	28
-#define	fr29	29
-#define	fr30	30
-#define	fr31	31
-
-#define	vr0		0
-#define	vr1		1
-#define	vr2		2
-#define	vr3		3
-#define	vr4		4
-#define	vr5		5
-#define	vr6		6
-#define	vr7		7
-#define	vr8		8
-#define	vr9		9
-#define	vr10	10
-#define	vr11	11
-#define	vr12	12
-#define	vr13	13
-#define	vr14	14
-#define	vr15	15
-#define	vr16	16
-#define	vr17	17
-#define	vr18	18
-#define	vr19	19
-#define	vr20	20
-#define	vr21	21
-#define	vr22	22
-#define	vr23	23
-#define	vr24	24
-#define	vr25	25
-#define	vr26	26
-#define	vr27	27
-#define	vr28	28
-#define	vr29	29
-#define	vr30	30
-#define	vr31	31
-
-#define	evr0	0
-#define	evr1	1
-#define	evr2	2
-#define	evr3	3
-#define	evr4	4
-#define	evr5	5
-#define	evr6	6
-#define	evr7	7
-#define	evr8	8
-#define	evr9	9
-#define	evr10	10
-#define	evr11	11
-#define	evr12	12
-#define	evr13	13
-#define	evr14	14
-#define	evr15	15
-#define	evr16	16
-#define	evr17	17
-#define	evr18	18
-#define	evr19	19
-#define	evr20	20
-#define	evr21	21
-#define	evr22	22
-#define	evr23	23
-#define	evr24	24
-#define	evr25	25
-#define	evr26	26
-#define	evr27	27
-#define	evr28	28
-#define	evr29	29
-#define	evr30	30
-#define	evr31	31
+#define fr0   0
+#define fr1   1
+#define fr2   2
+#define fr3   3
+#define fr4   4
+#define fr5   5
+#define fr6   6
+#define fr7   7
+#define fr8   8
+#define fr9   9
+#define fr10  10
+#define fr11  11
+#define fr12  12
+#define fr13  13
+#define fr14  14
+#define fr15  15
+#define fr16  16
+#define fr17  17
+#define fr18  18
+#define fr19  19
+#define fr20  20
+#define fr21  21
+#define fr22  22
+#define fr23  23
+#define fr24  24
+#define fr25  25
+#define fr26  26
+#define fr27  27
+#define fr28  28
+#define fr29  29
+#define fr30  30
+#define fr31  31
+
+#define vr0   0
+#define vr1   1
+#define vr2   2
+#define vr3   3
+#define vr4   4
+#define vr5   5
+#define vr6   6
+#define vr7   7
+#define vr8   8
+#define vr9   9
+#define vr10  10
+#define vr11  11
+#define vr12  12
+#define vr13  13
+#define vr14  14
+#define vr15  15
+#define vr16  16
+#define vr17  17
+#define vr18  18
+#define vr19  19
+#define vr20  20
+#define vr21  21
+#define vr22  22
+#define vr23  23
+#define vr24  24
+#define vr25  25
+#define vr26  26
+#define vr27  27
+#define vr28  28
+#define vr29  29
+#define vr30  30
+#define vr31  31
+
+#define evr0   0
+#define evr1   1
+#define evr2   2
+#define evr3   3
+#define evr4   4
+#define evr5   5
+#define evr6   6
+#define evr7   7
+#define evr8   8
+#define evr9   9
+#define evr10  10
+#define evr11  11
+#define evr12  12
+#define evr13  13
+#define evr14  14
+#define evr15  15
+#define evr16  16
+#define evr17  17
+#define evr18  18
+#define evr19  19
+#define evr20  20
+#define evr21  21
+#define evr22  22
+#define evr23  23
+#define evr24  24
+#define evr25  25
+#define evr26  26
+#define evr27  27
+#define evr28  28
+#define evr29  29
+#define evr30  30
+#define evr31  31
 
 /* Special Purpose Registers (SPRs) */
-#define	xer		1
-#define lr		8
-#define ctr		9
-#define	dec		22
-#define	sdr1	25
-#define	srr0	26
-#define srr1	27
-#define	sprg0	272
-#define	sprg1	273
-#define	sprg2	274
-#define	sprg3	275
-#define	prv		287
-#define ibat0u	528
-#define ibat0l	529
-#define ibat1u	530
-#define ibat1l	531
-#define ibat2u	532
-#define ibat2l	533
-#define ibat3u	534
-#define ibat3l	535
-#define dbat0u	536
-#define dbat0l	537
-#define dbat1u	538
-#define dbat1l	539
-#define dbat2u	540
-#define dbat2l	541
-#define dbat3u	542
-#define dbat3l	543
-#define hid0	1008
+#define xer      1
+#define lr       8
+#define ctr      9
+#define dec      22
+#define sdr1     25
+#define srr0     26
+#define srr1     27
+#define sprg0    272
+#define sprg1    273
+#define sprg2    274
+#define sprg3    275
+#define prv      287
+#define ibat0u   528
+#define ibat0l   529
+#define ibat1u   530
+#define ibat1l   531
+#define ibat2u   532
+#define ibat2l   533
+#define ibat3u   534
+#define ibat3l   535
+#define dbat0u   536
+#define dbat0l   537
+#define dbat1u   538
+#define dbat1l   539
+#define dbat2u   540
+#define dbat2l   541
+#define dbat3u   542
+#define dbat3l   543
+#define tlbmiss  980
+#define ptehi    981
+#define ptelo    982
+#define hid0     1008
 
 /* MSR bits */
-#define msr_dr	(1 << 4)
-#define msr_ir	(1 << 5)
-#define msr_pr	(1 << 14)
-#define msr_ee	(1 << 15)
+#define msr_dr  (1 << 4)
+#define msr_ir  (1 << 5)
+#define msr_pr  (1 << 14)
+#define msr_ee  (1 << 15)
 
 /* HID0 bits */
-#define hid0_sten	(1 << 24)
-#define hid0_ice	(1 << 15)
-#define hid0_dce	(1 << 14)
-#define hid0_icfi	(1 << 11)
-#define hid0_dci	(1 << 10)
+#define hid0_sten  (1 << 24)
+#define hid0_ice   (1 << 15)
+#define hid0_dce   (1 << 14)
+#define hid0_icfi  (1 << 11)
+#define hid0_dci   (1 << 10)
 
 #endif
Index: boot/arch/sparc64/loader/asm.S
===================================================================
--- boot/arch/sparc64/loader/asm.S	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/sparc64/loader/asm.S	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -31,6 +31,6 @@
 #include <register.h>
 
-.register       %g2, #scratch
-.register       %g3, #scratch
+.register %g2, #scratch
+.register %g3, #scratch
 
 .text
@@ -43,60 +43,67 @@
 	ba %xcc, halt
 	nop
+
+memcpy:
+	mov %o0, %o3      ! save dst
+	add %o1, 7, %g1
+	and %g1, -8, %g1
+	cmp %o1, %g1
+	be,pn %xcc, 3f
+	add %o0, 7, %g1
+	mov 0, %g3
 	
-memcpy:
-	mov	%o0, %o3		! save dst
-	add	%o1, 7, %g1
-	and	%g1, -8, %g1
-	cmp	%o1, %g1
-	be,pn	%xcc, 3f
-	add	%o0, 7, %g1
-	mov	0, %g3
-0:
-	brz,pn	%o2, 2f
-	mov	0, %g2
-1:
-	ldub	[%g3 + %o1], %g1
-	add	%g2, 1, %g2
-	cmp	%o2, %g2
-	stb	%g1, [%g3 + %o0]
-	bne,pt	%xcc, 1b
-	mov	%g2, %g3
-2:
-	jmp	%o7 + 8			! exit point
-	mov	%o3, %o0
-3:
-	and	%g1, -8, %g1
-	cmp	%o0, %g1
-	bne,pt	%xcc, 0b
-	mov	0, %g3
-	srlx	%o2, 3, %g4
-	brz,pn	%g4, 5f
-	mov	0, %g5
-4:
-	sllx	%g3, 3, %g2
-	add	%g5, 1, %g3
-	ldx	[%o1 + %g2], %g1
-	mov	%g3, %g5
-	cmp	%g4, %g3
-	bne,pt	%xcc, 4b
-	stx	%g1, [%o0 + %g2]
-5:
-	and	%o2, 7, %o2
-	brz,pn	%o2, 2b
-	sllx	%g4, 3, %g1
-	mov	0, %g2
-	add	%g1, %o0, %o0
-	add	%g1, %o1, %g4
-	mov	0, %g3
-6:
-	ldub	[%g2 + %g4], %g1
-	stb	%g1, [%g2 + %o0]
-	add	%g3, 1, %g2
-	cmp	%o2, %g2
-	bne,pt	%xcc, 6b
-	mov	%g2, %g3
-
-	jmp	%o7 + 8			! exit point
-	mov	%o3, %o0
+	0:
+		brz,pn %o2, 2f
+		mov 0, %g2
+	
+	1:
+		ldub [%g3 + %o1], %g1
+		add %g2, 1, %g2
+		cmp %o2, %g2
+		stb %g1, [%g3 + %o0]
+		bne,pt %xcc, 1b
+		mov %g2, %g3
+	
+	2:
+		jmp %o7 + 8   ! exit point
+		mov %o3, %o0
+	
+	3:
+		and %g1, -8, %g1
+		cmp %o0, %g1
+		bne,pt %xcc, 0b
+		mov 0, %g3
+		srlx %o2, 3, %g4
+		brz,pn %g4, 5f
+		mov 0, %g5
+	
+	4:
+		sllx %g3, 3, %g2
+		add %g5, 1, %g3
+		ldx [%o1 + %g2], %g1
+		mov %g3, %g5
+		cmp %g4, %g3
+		bne,pt %xcc, 4b
+		stx %g1, [%o0 + %g2]
+	
+	5:
+		and %o2, 7, %o2
+		brz,pn %o2, 2b
+		sllx %g4, 3, %g1
+		mov 0, %g2
+		add %g1, %o0, %o0
+		add %g1, %o1, %g4
+		mov 0, %g3
+	
+	6:
+		ldub [%g2 + %g4], %g1
+		stb %g1, [%g2 + %o0]
+		add %g3, 1, %g2
+		cmp %o2, %g2
+		bne,pt %xcc, 6b
+		mov %g2, %g3
+	
+	jmp %o7 + 8   ! exit point
+	mov %o3, %o0
 
 jump_to_kernel:
@@ -107,51 +114,55 @@
 	 * 3. Flush instruction pipeline.
 	 */
-
+	
 	/*
 	 * US3 processors have a write-invalidate cache, so explicitly
 	 * invalidating it is not required. Whether to invalidate I-cache
-	 * or not is decided according to the value of the global
-	 * "subarchitecture" variable (set in the bootstrap).
+	 * or not is decided according to the value of the 5th argument
+	 * (subarchitecture).
 	 */
-	set subarchitecture, %g2
-	ldub [%g2], %g2
-	cmp %g2, 3
+	cmp %i4, 3
 	be %xcc, 1f
 	nop
-0:
-	call icache_flush
-	nop
-1:
-	membar #StoreStore
+	
+	0:
+		call icache_flush
+		nop
+	
+	1:
+		membar #StoreStore
 	
 	/*
 	 * Flush the instruction pipeline.
 	 */
-	flush	%i7
-
+	flush %i7
+	
 	mov %o0, %l1
 	mov %o1, %o0
 	mov %o2, %o1
 	mov %o3, %o2
-	jmp %l1				! jump to kernel
+	jmp %l1       ! jump to kernel
 	nop
 
-#define ICACHE_SIZE		8192
-#define ICACHE_LINE_SIZE	32
-#define ICACHE_SET_BIT		(1 << 13)
-#define ASI_ICACHE_TAG		0x67
+#define ICACHE_SIZE       8192
+#define ICACHE_LINE_SIZE  32
+#define ICACHE_SET_BIT    (1 << 13)
+#define ASI_ICACHE_TAG    0x67
 
 # Flush I-cache
 icache_flush:
-	set	((ICACHE_SIZE - ICACHE_LINE_SIZE) | ICACHE_SET_BIT), %g1
-	stxa	%g0, [%g1] ASI_ICACHE_TAG
-0:	membar	#Sync
-	subcc	%g1, ICACHE_LINE_SIZE, %g1
-	bnz,pt	%xcc, 0b
-	stxa	%g0, [%g1] ASI_ICACHE_TAG
-	membar	#Sync
+	set ((ICACHE_SIZE - ICACHE_LINE_SIZE) | ICACHE_SET_BIT), %g1
+	stxa %g0, [%g1] ASI_ICACHE_TAG
+	
+	0:
+		membar #Sync
+		subcc %g1, ICACHE_LINE_SIZE, %g1
+		bnz,pt %xcc, 0b
+	
+	stxa %g0, [%g1] ASI_ICACHE_TAG
+	membar #Sync
 	retl
 	! SF Erratum #51
 	nop
+
 .global ofw
 ofw:
@@ -159,14 +170,14 @@
 	set ofw_cif, %l0
 	ldx [%l0], %l0
-
+	
 	rdpr  %pstate, %l1
 	and  %l1, ~PSTATE_AM_BIT, %l2
 	wrpr  %l2, 0, %pstate
-    
+	
 	jmpl %l0, %o7
 	mov %i0, %o0
-
+	
 	wrpr %l1, 0, %pstate
-
+	
 	ret
 	restore %o0, 0, %o0
